package com.mortals.xhx.module.window.service.impl;

import com.mortals.framework.exception.AppException;
import com.mortals.framework.model.Context;
import com.mortals.framework.model.PageInfo;
import com.mortals.xhx.module.workman.model.WorkmanEntity;
import com.mortals.xhx.module.workman.model.WorkmanQuery;
import com.mortals.xhx.module.workman.service.WorkmanService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.mortals.framework.service.impl.AbstractCRUDServiceImpl;
import com.mortals.xhx.module.window.dao.WindowDao;
import com.mortals.xhx.module.window.model.WindowEntity;
import com.mortals.xhx.module.window.service.WindowService;
import org.springframework.util.ObjectUtils;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * WindowService
 * 站点部门窗口 service实现
 *
 * @author zxfei
 * @date 2022-01-12
 */
@Service("windowService")
public class WindowServiceImpl extends AbstractCRUDServiceImpl<WindowDao, WindowEntity, Long> implements WindowService {

    @Autowired
    private WorkmanService workmanService;


    @Override
    protected void findAfter(WindowEntity params, PageInfo pageInfo, Context context, List<WindowEntity> list) throws AppException {
        Map<Long, List<WorkmanEntity>> collect = workmanService.find(new WorkmanQuery()).stream().collect(Collectors.groupingBy(x -> x.getWindowId()));
        list.stream().peek(item -> {
            if (!ObjectUtils.isEmpty(collect.get(item.getId()))) {
                item.setWorkmanList(collect.get(item.getId()));
            }
        }).count();
        super.findAfter(params, pageInfo, context, list);
    }
}